%global momorel 3

Summary: mdadm controls Linux md devices (software RAID arrays)
Name: mdadm
Version: 3.1.2
Release: %{momorel}m%{?dist}
License: GPLv2+
Group: System Environment/Base
URL: http://www.cse.unsw.edu.au/~neilb/source/mdadm/
Source0: http://www.kernel.org/pub/linux/utils/raid/%{name}/%{name}-%{version}.tar.bz2
NoSource: 0
Source1: mdmonitor.init
Source2: raid-check
Source3: %{name}-raid-check-sysconfig
Source4: %{name}.rules
Patch1: %{name}-%{version}-mapfile.patch
Patch2: %{name}-%{version}-mapname.patch
Patch3: %{name}-3.1.1-endian.patch
Patch4: %{name}-%{version}-rebuild.patch
Patch5: %{name}-%{version}-directory.patch
Patch6: %{name}-%{version}-decremental.patch
Patch7: %{name}-%{version}-decremental-2.patch
Patch8: %{name}-%{version}-decremental-3.patch
Patch9: %{name}-%{version}-powerpc-compile.patch
Patch10: %{name}-%{version}-container.patch
Patch11: %{name}-%{version}-container-2.patch
Patch20: %{name}-2.5.2-static.patch
BuildRoot:   %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post): initscripts, chkconfig
Requires(preun):  initscripts, chkconfig
Requires(postun):  initscripts
Requires: udev
BuildRequires: coreutils
BuildRequires: glibc-static
Obsoletes:   mdctl,raidtools

%description 
The mdadm program is used to create, manage, and monitor Linux MD (software
RAID) devices.  As such, it provides similar functionality to the raidtools
package.  However, mdadm is a single program, and it can perform
almost all functions without a configuration file, though a configuration
file can be used to help with some common tasks.

%prep
%setup -q

%patch1 -p1 -b .mapfile
%patch2 -p1 -b .mapname
%patch3 -p1 -b .endian
%patch4 -p1 -b .rebuild
%patch5 -p1 -b .directory
%patch6 -p1 -b .decremental
%patch7 -p1 -b .decremental-2
%patch8 -p1 -b .decremental-3
%patch9 -p1 -b .powerpc
%patch10 -p1 -b .container
%patch11 -p1 -b .container-2
%patch20 -p1 -b .static

%build
make %{?_smp_mflags} \
    CXFLAGS="%{optflags} -fno-strict-aliasing" \
    SYSCONFDIR="%{_sysconfdir}" \
    %{name}.static %{name}

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

make DESTDIR=%{buildroot} MANDIR=%{_mandir} BINDIR=/sbin install install-static

install -Dp -m 755 %{SOURCE1} %{buildroot}%{_initscriptdir}/mdmonitor
install -Dp -m 755 %{SOURCE2} %{buildroot}%{_sysconfdir}/cron.weekly/99-raid-check
install -Dp -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/raid-check
install -Dp -m 644 %{SOURCE4} %{buildroot}/lib/udev/rules.d/65-md-incremental.rules

mkdir -p -m 700 %{buildroot}%{_var}/run/%{name}

# 64-md-raid.rules is installed by udev-151-4m
rm -f %{buildroot}/lib/udev/rules.d/64-md-raid.rules

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%post
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add mdmonitor
fi

%preun
if [ "$1" = 0 ]; then
    service mdmonitor stop > /dev/null 2>&1 ||:
    /sbin/chkconfig --del mdmonitor
fi

%postun
if [ "$1" -ge "1" ]; then
    service mdmonitor condrestart > /dev/null 2>&1
fi

%files
%defattr(-,root,root,-)
%doc ANNOUNCE-3.* COPYING ChangeLog TODO README.initramfs
%doc %{name}.conf-example misc/syslog-events
%{_sysconfdir}/cron.weekly/99-raid-check
%{_initscriptdir}/mdmonitor
%config(noreplace) %{_sysconfdir}/sysconfig/raid-check
/lib/udev/rules.d/65-md-incremental.rules
/sbin/%{name}
/sbin/%{name}.static
/sbin/mdmon
%{_mandir}/man4/md.4*
%{_mandir}/man5/%{name}.conf.5*
%{_mandir}/man8/%{name}.8*
%{_mandir}/man8/mdmon.8*
%attr(0700,root,root) %dir %{_var}/run/mdadm

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.2-3m)
- full rebuild for mo7 release

* Tue Jul 20 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (3.1.2-2m)
- modify %%build section
- import 11 patches from Fedora
- update static.patch
- import mdadm-raid-check-sysconfig from Fedora
- update mdadm.rules, mdmonitor.init and raid-check
- re-write %%files

* Sat Mar 13 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.2-1m)
- version 3.1.2

* Fri Jan 22 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (3.1.1-1m)
- version 3.1.1

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.1-3m)
- rebuild against gcc-4.4 and glibc-2.11

* Tue Oct 27 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (3.1-2m)
- temporarily drop -Werror

* Mon Oct 26 2009 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (3.1-1m)
- version 3.1

* Sat Oct 17 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (3.0.2-1m)
- update 3.0.2 release

* Tue Jun 30 2009 Yohsuke Ooi <meke@momonga-linux.org> 
- (3.0.0-1m)
- update 3.0.0 release

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.6.7-4m)
- rebuild against rpm-4.6

* Mon Jan 12 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.6.7-3m)
- update Patch4 for fuzz=0
- License: GPLv2+

* Mon Jul  7 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.6.7-2m)
- rewind Source2: mdadm.rules to avoid degrading array at every system start-up
- https://bugzilla.redhat.com/show_bug.cgi?id=453314

* Fri Jul  4 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (2.6.7-1m)
- update 2.6.7

* Fri May  2 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.4-3m)
- merge Fedora 2.6.4-4  for upstart
- add Patch6: mdadm-2.6.4-incremental.patch
-
- fedora 2.6.4 changelog is below
- * Thu Apr 17 2008 Bill Nottingham <notting@redhat.com> - 2.6.4-4
- - make /dev/md if necessary in incremental mode (#429604)
- - open RAID devices with O_EXCL to avoid racing against other --incremental processes (#433932)
- 
- * Fri Feb  1 2008 Bill Nottingham <notting@redhat.com> - 2.6.4-3
- - add a udev rules file for device assembly (#429604)
-
- * Fri Jan 18 2008 Doug Ledford <dledford@redhat.com> - 2.6.4-2
- - Bump version and rebuild
-
- * Fri Oct 19 2007 Doug Ledford <dledford@redhat.com> - 2.6.4-1
- - Update to latest upstream and remove patches upstream has taken

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.6.4-2m)
- rebuild against gcc43

* Tue Feb  5 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (2.6.4-1m)
- update 2.6.4

* Tue Jul 24 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.6.1-4m)
- revise %%preun and %%postun for Momonga Linux 4 beta2

* Mon Jul 23 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.6.1-3m)
- move start up script from %%{_initrddir} to %%{_initscriptdir}

* Wed Jun 20 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (2.6.1-2m)
- disable service at initial start up

* Sat Jun 16 2007 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.6.1-1m)
- Patch7: mdadm-2.6.1-build.mo.patch (original copied from fc devel)

* Sat Nov 11 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.5.6-1m)
- patches from fc7

* Sat Apr 1 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.4-1m)
- version 2.4

* Sun Feb 12 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.3.1-1m)
- version 2.3.1

* Sat Jan  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.2-1m)
- sync with fc-devel

* Tue Nov  8 2005 Yohsuke Ooi <meke@momonga-linux.org>
- (1.6.0-2m)
- add gcc4 patch
- Patch1:      mdadm-1.6.0-gcc4.patch
- Patch2:      mdadm-1.6.0-gcc4-2.patch

* Sat Mar 12 2005 Toru Hoshina <t@momonga-linux.org>
- (1.6.0-1m)
- ver up. sync with FC3(1.6.0-2).

* Sat Feb 19 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.3.0-3m)
- revised docdir permission

* Mon Sep 20 2004 Shotaro Kamio <skamio@momonga-linux.org>
- add patch0 for kernel 2.6

* Sun Jul  4 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.3.0-2m)
- stop daemon

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (1.3.0-1m)
- import from FC1.

* Wed Sep 10 2003 Michael K. Johnson <johnsonm@redhat.com> 1.3.0-1
- sync upstream

* Tue Mar 11 2003 Michael K. Johnson <johnsonm@redhat.com> 1.1.0-1
- sync upstream

* Tue Jan 28 2003 Michael K. Johnson <johnsonm@redhat.com> 1.0.1-1
- update for rebuild

* Wed Dec 25 2002 Tim Powers <timp@redhat.com> 1.0.0-8
- fix references to %%install in the changelog so that it will build

* Fri Dec 13 2002 Elliot Lee <sopwith@redhat.com> 1.0.0-7
- Rebuild

* Fri Jul 12 2002 Michael K. Johnson <johnsonm@redhat.com>
- Changed RPM Group to System Environment/Base

* Wed May 15 2002 Michael K. Johnson <johnsonm@redhat.com>
- minor cleanups to the text, conditionalize rm -rf
- added mdmonitor init script

* Fri May 10 2002  <neilb@cse.unsw.edu.au>
- update to 1.0.0
- Set CXFLAGS instead of CFLAGS

* Sat Apr  6 2002  <neilb@cse.unsw.edu.au>
- change %%install to use "make install"

* Fri Mar 15 2002  <gleblanc@localhost.localdomain>
- beautification
- made mdadm.conf non-replaceable config
- renamed Copyright to License in the header
- added missing license file
- used macros for file paths

* Fri Mar 15 2002 Luca Berra <bluca@comedia.it>
- Added Obsoletes: mdctl
- missingok for configfile

* Wed Mar 12 2002 NeilBrown <neilb@cse.unsw.edu.au>
- Add md.4 and mdadm.conf.5 man pages

* Fri Mar 08 2002		Chris Siebenmann <cks@cquest.utoronto.ca>
- builds properly as non-root.

* Fri Mar 08 2002 Derek Vadala <derek@cynicism.com>
- updated for 0.7, fixed /usr/share/doc and added manpage

* Tue Aug 07 2001 Danilo Godec <danci@agenda.si>
- initial RPM build
